﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualBasic.FileIO;
using System.Diagnostics;
using System.IO;

namespace テキスト反復ツール
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // CSVファイル選択
        private void button1_Click(object sender, EventArgs e)
        {
            // 以下の３行は オプション（なくてもＯＫ）
            openFileDialog1.Title            = "CSVファイルの選択" ;  // タイトルバーの文字列
            // openFileDialog1.InitialDirectory = "???" ;  // 最初に表示されるディレクトリ
            openFileDialog1.Filter = "CSVファイル (*.csv)|*.csv";  //「ファイルの種類」を指定

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = openFileDialog1.FileName;
            }
        }

        // テンプレート選択
        private void button2_Click(object sender, EventArgs e)
        {
            // 以下の３行は オプション（なくてもＯＫ）
            openFileDialog1.Title = "テンプレートの選択";  // タイトルバーの文字列
            // openFileDialog1.InitialDirectory = "???" ;  // 最初に表示されるディレクトリ
            openFileDialog1.Filter = "HTMLファイル (*.html;*.htm)|*.html;*.htm|テキストファイル (*.txt)|*.txt|すべてのファイル (*.*)|*.*";  //「ファイルの種類」を指定

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = openFileDialog1.FileName;
            }
        }

        // 出力先選択
        private void button5_Click(object sender, EventArgs e)
        {
            // 以下の３行は オプション（なくてもＯＫ）
            saveFileDialog1.Title            = "出力先の指定" ;  // タイトルバーの文字列
            // saveFileDialog1.InitialDirectory = "???" ;  // 最初に表示されるディレクトリ
            saveFileDialog1.Filter = "HTMLファイル (*.html;*.htm)|*.html;*.htm|テキストファイル (*.txt)|*.txt|すべてのファイル (*.*)|*.*";  //「ファイルの種類」を指定

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox5.Text = saveFileDialog1.FileName;
            }
        }

        // 実行
        private void button3_Click(object sender, EventArgs e)
        {
            // ファイル確認
            if (!File.Exists(textBox1.Text))
            {
                MessageBox.Show("CSVファイルがありません。","読み込みエラー",MessageBoxButtons.OK,MessageBoxIcon.Warning);
                return;
            }
            if (!File.Exists(textBox2.Text))
            {
                MessageBox.Show("テンプレートがありません。", "読み込みエラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            if (textBox3.Text.Length < 1)
            {
                MessageBox.Show("開始記号を入力してください。", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            if (textBox4.Text.Length < 1)
            {
                MessageBox.Show("終了記号を入力してください。", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            if (textBox5.Text.Length < 1)
            {
                MessageBox.Show("出力先を指定してください。", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            

            // 行数取得
            int linecnt = lineCount(textBox1.Text);

            // テンプレートの読み込み
            StreamReader reader = new StreamReader(textBox2.Text, Encoding.GetEncoding("Shift_JIS"));
            string template = reader.ReadToEnd();
            reader.Close();
            int start_point = template.IndexOf(textBox3.Text);
            if (start_point < 0) 
            {
                MessageBox.Show("開始記号が見つかりません。", "読み込みエラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            if (template.IndexOf(textBox4.Text, start_point) < 0)
            {
                MessageBox.Show("終了記号が見つかりません。", "読み込みエラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            // テキストデータを反復記号で分割
            string tmp_pre = template.Substring(0, template.IndexOf(textBox3.Text));
            template = template.Substring(template.IndexOf(textBox3.Text) + textBox3.Text.Length);
            string tmp_mid = template.Substring(0, template.IndexOf(textBox4.Text));
            template = template.Substring(template.IndexOf(textBox4.Text) + textBox4.Text.Length);
            string tmp_fin = template;

            // TextFieldParserクラスのコンストラクタ呼び出し
            TextFieldParser parser = new TextFieldParser(textBox1.Text,
                System.Text.Encoding.GetEncoding("Shift_JIS"));

            // フィールドがコンマで区切られている場合の設定
            parser.TextFieldType = FieldType.Delimited;
            parser.SetDelimiters(","); // 区切り文字はコンマ

            // 差込記号の取得
            if (parser.EndOfData)
            {
                MessageBox.Show("CSVファイルの読み込みに失敗しました。", "読み込みエラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }
            string[] kigou = parser.ReadFields(); // 1行読み込み
            if (kigou.Length < 1) 
            {
                MessageBox.Show("差込記号の読み込みに失敗しました。", "読み込みエラー", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;
            }

            // CSVファイル全体を読み込みながら処理するループ
            Form2 form2 = new Form2();
            form2.setMax(linecnt);
            form2.Show(this);
            int cnt = 0;
            form2.setValue(++cnt);
            StreamWriter writer = new StreamWriter(textBox5.Text, false,  // 上書き （ true = 追加 ）
                                                   Encoding.GetEncoding("Shift_JIS"));
            writer.Write(tmp_pre);
            while (!parser.EndOfData)
            {
                string[] row = parser.ReadFields(); // 1行読み込み
                string buf = tmp_mid; // 出力用バッファ
                for (int idx = 0; idx < row.Length; idx++)
                {
                    buf = buf.Replace(kigou[idx], row[idx]); // 置換
                }
                writer.Write(buf);

                form2.setValue(++cnt);
                Application.DoEvents();
                //System.Threading.Thread.Sleep(10000); 
            }
            writer.Write(tmp_fin);
            writer.Close();
            form2.Dispose();
            Process.Start("explorer.exe", "/n,"+Path.GetDirectoryName(textBox5.Text));
        }

        // 行数取得
        private int lineCount(string fname)
        {
            int count = 0;
            StreamReader reader = new StreamReader(fname,Encoding.GetEncoding("Shift_JIS"));
            while (reader.ReadLine() != null)
            {
                count++;
            }
            reader.Close();

            return count;
        }

        // 終了
        private void button4_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

   }
}